Subject: Re: skb_checksum_help

From: "David S. Miller" <[email-masked]>
Date: Tue, 25 Jan 2005 15:30:20 -0800

On Tue, 25 Jan 2005 22:15:24 +0100
Thomas Graf <[email-masked]> wrote:

> I thought about this too and actually implemented it but it means to
> change all relevant drivers and the only feature that might be
> driver specific is checksumming, given I didn't make any mistakes
> while checking the drivers for pskb compatibility.

It is not only checksumming, but also TSO.  TSO, like checksumming,
is a feature where the chip must parse the packet to figure out where
to do it's work.  In fact, TSO is a prime suspect for VLAN problems
as the card must duplicate the VLAN headers properly as it chops
up the TSO frame into MSS sized pieces.